function [x,task] = sim_corr_data(stim_design,std_noise,mus,Covs);

% Simulate 2-node network for a Block Design
x = zeros(2,length(stim_design));
for t = 1:length(stim_design)
    if stim_design(t) == 0
        x(:,t) = mvnrnd(mus(1,:),Covs(:,:,1));
    else
        x(:,t) = mvnrnd(mus(2,:),Covs(:,:,2));
    end
end
x = x +randn(size(x)).*std_noise;
task = zeros(1,length(stim_design));
task(stim_design == 0) = 1;
task(stim_design == 1) = 2;


